<?php
class likeIt extends plxPlugin {
	public function __construct($default_lang) {
		# appel du constructeur de la classe plxPlugin (obligatoire)
		parent::__construct($default_lang);

		# limite l'accès à l'écran d'administration du plugin
		# PROFIL_ADMIN , PROFIL_MANAGER , PROFIL_MODERATOR , PROFIL_EDITOR , PROFIL_WRITER
		$this->setConfigProfil(PROFIL_ADMIN);
		
		# Déclaration d'un hook (existant ou nouveau)
		$this->addHook('plxMotorParseCommentaire','plxMotorParseCommentaire');
		$this->addHook('ThemeEndBody','ThemeEndBody');
		$this->addHook('likeButton_here','likeButton_here');
		$this->addHook('whoLikesIt','whoLikesIt');

		
	}

	# Activation / désactivation
	public function OnActivate() {
		# code à exécuter à l’activation du plugin
		# Création du dossier avatars si inexistant
		if (!is_file(PLX_PLUGINS.'likeIt/likes.dat')){$this->save(array('article'=>array(),'comment'=>array()));chmod(PLX_PLUGINS.'likeIt/likes.dat',0777);}

	}
	public function OnDeactivate() {
		# code à exécuter à la désactivation du plugin
	}
	
	public function load(){
		$filename=PLX_PLUGINS.'likeIt/likes.dat';
		return unserialize(file_get_contents($filename));
	}	
	public function save($data){
		$filename=PLX_PLUGINS.'likeIt/likes.dat';
		file_put_contents($filename,serialize($data));
	}
	public function getName($userid){
		global $plxMotor,$plxAdmin;
		if (!empty($plxMotor)){$ausers=$plxMotor->aUsers;}else{$ausers=$plxAdmin->aUsers;}
		return $ausers[$userid]['name'];
	}

	# HOOKS
	public function ThemeEndBody(){
		echo '
			<script>
				function save_like(obj){
					href=obj.getAttribute("href");
					request = new XMLHttpRequest;
					request.open("GET",href, true);
					request.send();
					// Gestion de la réponse du serveur
					request.onreadystatechange=function(){
					  if (request.readyState==4 && request.status==200){	
					  	rep=request.responseText;				  	
					  	obj.innerHTML=rep;
					  	obj.classList.toggle("like"); 
					  	obj.classList.toggle("dislike"); 
					  }
					}
					return false;
				}
			</script>
		';
	}
	public function likeButton_here($param){ // array('article','nb')
		if (empty($param)||empty($param[1])||empty($param[0])){return;}
		$likes=$this->load();
		// déterminer si le user a déjà liké cet article/comment : non=> like / oui => dislike
		if (in_array($_SESSION['user'], $likes[$param[0]][$param[1]])){
			$msg='Ne plus aimer';
			$class='dislike';
		}else{
			$msg='Aimer';
			$class='like';
		}

		echo '<p class="like_button "><a class="'.$class.'" onclick="save_like(this);return false;" href="'.PLX_PLUGINS.'likeIt/savelike.php?number='.$_SESSION['user'].'&what='.$param[0].'&id='.$param[1].'">'.$msg.'</a></p>';
	
	}
	public function whoLikesIt($param){ //array('article','nb') echo liste des gens qui aiment 
		$likes=$this->load();
		if (empty($param[0])||empty($param[1])||empty($likes[$param[0]][$param[1]])){return;}
		foreach ($likes[$param[0]][$param[1]] as $user){
			$users[]=$this->getName($user);
		}
		echo '<div class="who_likes_it">'. implode (',',$users).' aime';
		if (count($users)>1){echo 'nt';}
		echo '</div>';
	}

	

}





/* Pense-bête:
 * Récuperer des parametres du fichier parameters.xml
 *	$this->getParam("<nom du parametre>")
 *	$this-> setParam ("param1", 12345, "numeric")
 *	$this->saveParams()
 *
 *	plxUtils::strCheck($string) : sanitize string
 *
 * 
 * Quelques constantes utiles: 
 * PLX_CORE
 * PLX_ROOT
 * PLX_CHARSET
 * PLX_CONFIG_PATH
 * PLX_PLUGINS
 *
 * Appel de HOOK
 *	eval($plxShow->callHook("ThemeEndHead","param1"))  ou eval($plxShow->callHook("ThemeEndHead",array("param1","param2")))
 *	ou $retour=$plxShow->callHook("ThemeEndHead","param1"));
 */
?>
